function spawn_ball()
    ball = {}
    --this will spawn the ball at a random location near the middle of the screen
    ball.x = love.window.getWidth() / 2
    ball.y = love.window.getHeight() / 2

    ball.speed = math.random(3, 5)
    ball.xmovement = math.random(1, 2)
    ball.ymovement = math.random(-8, 8)

    ball.timeLeft = 5

end

function ballMovement()
    if ball.xmovement == 1 then
        ball.x = ball.x - ball.speed
    else
        ball.x = ball.x + ball.speed
    end
    ball.y = ball.y + ball.ymovement
end


function ballCollision()
    if ball.x >= love.window.getWidth() - 20 and ball.y >= p2.y and ball.y <= p2.y + p2.height then
        ball.xmovement = 1 --change the direction of the ball
        ball.speed = ball.speed + 1

    elseif ball.x >= love.window.getWidth() - 20 and ball.y >= p2.y + (p2.height) and ball.y <= p2.y + p2.height then
        ball.xmovement = 1
        ball.speed = ball.speed + 1
        --player 1 collision
    elseif ball.x <=20 and ball.y >= p1.y + p1.height and ball.y <= p1.y + p1.height then
        ball.dxmovement= 2
        ball.speed = ball.speed + 1
    elseif ball.x <= 20 and ball.y >= p1.y and ball.y <= p1.y + p1.height then
        ball.xmovement = 2 --change the direction of the ball
        ball.speed = ball.speed + 1
            --collision for the top and bottom borders
    elseif ball.y > love.window.getHeight() - 4 then
        ball.ymovement = ball.ymovement * -1
    elseif ball.y < 4 then
        ball.ymovement = ball.ymovement * -1
    end
end

function updateScore()
    --update the player's score when the ball crosses the opponent's side
    if ball.x > love.window.getWidth() + 4 then --if the ball crosses the right side
        score_p1 = score_p1 + 1
        spawn_ball() --respawn the ball
		pauseTimeout = 4
    elseif ball.x < -4 then --if the ball crosses the left side
        score_p2 = score_p2 + 1
        spawn_ball()
		pauseTimeout = 4
    end
end

function checkSpeed()
    if ball.speed > 15 then
        ball.speed = 15
    end
end



function drawBall()
        love.graphics.circle("fill", ball.x, ball.y, 8, 8)
end
